/*  miniboxtk - small GUI toolkit/widget system
    Copyright (C) 2022  Tibor 'Igor2' Palinkas

    (Supported by NLnet NGI0 PET Fund in 2022)

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

    Contact:
      Project page: http://repo.hu/projects/miniboxtk
      contact lead developer: http://www.repo.hu/projects/miniboxtk/contact.html
*/

#ifndef LIBMBTK_WIDGET_COMMON_H
#define LIBMBTK_WIDGET_COMMON_H

/* Common frame: fallback draw for widgets that are dranw as a box */
int mbtk_comm_frame_fallback_minsize(mbtk_widget_t *w, long *mx, long *my);
void mbtk_comm_frame_fallback_draw(mbtk_widget_t *w);
void mbtk_comm_frame_fallback_draw_overlay(mbtk_widget_t *w);

/* Same, but clears flags.activated for the draw */
int mbtk_comm_frame_fallback_minsize_inactive(mbtk_widget_t *w, long *mx, long *my);
void mbtk_comm_frame_fallback_draw_inactive(mbtk_widget_t *w);


/* embed1: helpers for widgets that embed a single child widget; parent widget
   is turned into a hbox. */
mbtk_widget_t *mbtk_comm_embed1_set_child(mbtk_widget_t *parent, mbtk_widget_t *w);

/* embed: helpers for widgets that embed a subtree widget; the whole subtree
   is created on host widget creation time, using dummy widgets (empty boxes).
   Later replace() is used to replace the dummies with the app supplied
   widgets. */
mbtk_widget_t *mbtk_comm_embed_replace(mbtk_widget_t *host, mbtk_widget_t *old, mbtk_widget_t *new);

#endif
