/*  miniboxtk - small GUI toolkit/widget system
    Copyright (C) 2022  Tibor 'Igor2' Palinkas

    (Supported by NLnet NGI0 PET Fund in 2022)

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

    Contact:
      Project page: http://repo.hu/projects/miniboxtk
      contact lead developer: http://www.repo.hu/projects/miniboxtk/contact.html
*/

#ifndef LIBMBTK_WIDGET_RADIOBUTTON_H
#define LIBMBTK_WIDGET_RADIOBUTTON_H

#include <libmbtk/config.h>
#include <libmbtk/widget.h>
#include <libmbtk/widget_inlines.h>

/* Radiobutton: has two states, in activated state includes a mark;
   can be clicked a mouse click release or enter release */
typedef struct mbtk_radiobutton_s {
	mbtk_widget_t w;
} mbtk_radiobutton_t;

/* Create a new radiobutton. Handler is set to hand_toggle. */
mbtk_radiobutton_t *mbtk_radiobutton_new(mbtk_radiobutton_t *caller_alloced);

/* Called after the release on a click on the radiobutton */
void mbtk_radiobutton_callback_toggle(mbtk_radiobutton_t *b, mbtk_event_handled_t (*cb)(mbtk_widget_t *w, mbtk_kw_t id, void *user_data), void *user_data);


MBTK_WIDGET_INLINES(radiobutton)

#endif
